StandardClassLoader (Tomcat API Documentation)
Keywords: org.apache.catalina.loader.StandardClassLoader class

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.catalina.loader
Class StandardClassLoader

    java.lang.Object
      java.lang.ClassLoader
          java.security.SecureClassLoader
              java.net.URLClassLoader
                  org.apache.catalina.loader.StandardClassLoader

All Implemented Interfaces:
  Reloader

public class StandardClassLoader
extends java.net.URLClassLoader
implements Reloader

Subclass implementation of java.net.URLClassLoader that knows how to load classes from disk directories, as well as local and remote JAR files. It also implements the `Reloader` interface, to provide automatic reloading support to the associated loader.

In all cases, URLs must conform to the contract specified by `URLClassLoader` - any URL that ends with a "/" character is assumed to represent a directory; all other URLs are assumed to be the address of a JAR file.

IMPLEMENTATION NOTE - Local repositories are searched in the order they are added via the initial constructor and/or any subsequent calls to `addRepository()`.

IMPLEMENTATION NOTE - At present, there are no dependencies from this class to any other Catalina class, so that it could be used independently.

Version:
  $Revision: 1.6 $ $Date: 2003/09/02 21:22:03 $
Author:
  Craig R. McClanahan, Remy Maucherat

Field Summary
`protected int` | `debug` The debugging detail level of this component.
`protected boolean` | `delegate` Should this class loader delegate to the parent class loader before searching its own repositories (i.e. the usual Java2 delegation model)?
`protected java.net.URLStreamHandlerFactory` | `factory` URL stream handler for additional protocols.
`protected java.lang.String[]` | `repositories` The list of local repositories, in the order they should be searched for locally loaded classes or resources.

Constructor Summary
`StandardClassLoader()` Construct a new ClassLoader with no defined repositories and no parent ClassLoader.
`StandardClassLoader(java.lang.ClassLoader parent)` Construct a new ClassLoader with no defined repositories and the specified parent ClassLoader.
`StandardClassLoader(java.lang.ClassLoader parent, java.net.URLStreamHandlerFactory factory)` Construct a new ClassLoader with no defined repositories and the specified parent ClassLoader.
`StandardClassLoader(java.lang.String[] repositories)` Construct a new ClassLoader with the specified repositories and no parent ClassLoader.
`StandardClassLoader(java.lang.String[] repositories, java.lang.ClassLoader parent)` Construct a new ClassLoader with the specified repositories and parent ClassLoader.
`StandardClassLoader(java.net.URL[] repositories, java.lang.ClassLoader parent)` Construct a new ClassLoader with the specified repositories and parent ClassLoader.
`StandardClassLoader(java.net.URLStreamHandlerFactory factory)` Construct a new ClassLoader with no defined repositories and no parent ClassLoader, but with a stream handler factory.

Method Summary
`void` | `addRepository(java.lang.String repository)` Add a new repository to the set of places this ClassLoader can look for classes to be loaded.
`protected void` | `addRepositoryInternal(java.lang.String repository)` Add a repository to our internal array only.
`protected static java.net.URL[]` | `convert(java.lang.String[] input)` Convert an array of String to an array of URL and return it.
`protected static java.net.URL[]` | `convert(java.lang.String[] input, java.net.URLStreamHandlerFactory factory)` Convert an array of String to an array of URL and return it.
`java.lang.Class` | `findClass(java.lang.String name)` Find the specified class in our local repositories, if possible.
`protected java.io.InputStream` | `findLoadedResource(java.lang.String name)` Finds the resource with the given name if it has previously been loaded and cached by this class loader, and return an input stream to the resource data.
`java.lang.String[]` | `findRepositories()` Return a String array of the current repositories for this class loader.
`java.net.URL` | `findResource(java.lang.String name)` Find the specified resource in our local repository, and return a `URL` refering to it, or `null` if this resource cannot be found.
`java.util.Enumeration` | `findResources(java.lang.String name)` Return an enumeration of `URLs` representing all of the resources with the given name.
`int` | `getDebug()` Return the debugging detail level for this component.
`boolean` | `getDelegate()` Return the "delegate first" flag for this class loader.
`protected java.security.PermissionCollection` | `getPermissions(java.security.CodeSource codeSource)` Get the Permissions for a CodeSource.
`java.net.URL` | `getResource(java.lang.String name)` Find the resource with the given name.
`java.io.InputStream` | `getResourceAsStream(java.lang.String name)` Find the resource with the given name, and return an input stream that can be used for reading it.
`java.lang.Class` | `loadClass(java.lang.String name)` Load the class with the specified name.
`java.lang.Class` | `loadClass(java.lang.String name, boolean resolve)` Load the class with the specified name, searching using the following algorithm until it finds and returns the class.
`boolean` | `modified()` This class loader doesn't check for reloading.
`protected static java.lang.String` | `parseProtocol(java.lang.String spec)` Parse URL protocol.
`void` | `setDebug(int debug)` Set the debugging detail level for this component.
`void` | `setDelegate(boolean delegate)` Set the "delegate first" flag for this class loader.
`protected void` | `setPermissions(java.lang.String path)` If there is a Java SecurityManager create a read FilePermission or JndiPermission for the file directory path.
`protected void` | `setPermissions(java.net.URL url)` If there is a Java SecurityManager add a read FilePermission or JndiPermission for URL.
`java.lang.String` | `toString()` Render a String representation of this object.

Methods inherited from class java.net.URLClassLoader
`addURL, definePackage, getURLs, newInstance, newInstance`

Methods inherited from class java.security.SecureClassLoader
`defineClass`

Methods inherited from class java.lang.ClassLoader
`clearAssertionStatus, defineClass, defineClass, defineClass, definePackage, findLibrary, findLoadedClass, findSystemClass, getPackage, getPackages, getParent, getResources, getSystemClassLoader, getSystemResource, getSystemResourceAsStream, getSystemResources, resolveClass, setClassAssertionStatus, setDefaultAssertionStatus, setPackageAssertionStatus, setSigners`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### debug

    protected int debug

  The debugging detail level of this component.

### delegate

    protected boolean delegate

  Should this class loader delegate to the parent class loader before searching its own repositories (i.e. the usual Java2 delegation model)? If set to `false`, this class loader will search its own repositories first, and delegate to the parent only if the class or resource is not found locally.

### repositories

    protected java.lang.String[] repositories

  The list of local repositories, in the order they should be searched for locally loaded classes or resources.

### factory

    protected java.net.URLStreamHandlerFactory factory

  URL stream handler for additional protocols.

Constructor Detail

### StandardClassLoader

    public StandardClassLoader()

  Construct a new ClassLoader with no defined repositories and no parent ClassLoader.

### StandardClassLoader

    public StandardClassLoader(java.net.URLStreamHandlerFactory factory)

  Construct a new ClassLoader with no defined repositories and no parent ClassLoader, but with a stream handler factory.

Parameters:
  `factory` - the URLStreamHandlerFactory to use when creating URLs

### StandardClassLoader

    public StandardClassLoader(java.lang.ClassLoader parent)

  Construct a new ClassLoader with no defined repositories and the specified parent ClassLoader.

Parameters:
  `parent` - The parent ClassLoader

### StandardClassLoader

    public StandardClassLoader(java.lang.ClassLoader parent,
                               java.net.URLStreamHandlerFactory factory)

  Construct a new ClassLoader with no defined repositories and the specified parent ClassLoader.

Parameters:
  `parent` - The parent ClassLoader
  `factory` - the URLStreamHandlerFactory to use when creating URLs

### StandardClassLoader

    public StandardClassLoader(java.lang.String[] repositories)

  Construct a new ClassLoader with the specified repositories and no parent ClassLoader.

Parameters:
  `repositories` - The initial set of repositories

### StandardClassLoader

    public StandardClassLoader(java.lang.String[] repositories,
                               java.lang.ClassLoader parent)

  Construct a new ClassLoader with the specified repositories and parent ClassLoader.

Parameters:
  `repositories` - The initial set of repositories
  `parent` - The parent ClassLoader

### StandardClassLoader

    public StandardClassLoader(java.net.URL[] repositories,
                               java.lang.ClassLoader parent)

  Construct a new ClassLoader with the specified repositories and parent ClassLoader.

Parameters:
  `repositories` - The initial set of repositories
  `parent` - The parent ClassLoader

Method Detail

### getDebug

    public int getDebug()

  Return the debugging detail level for this component.

### setDebug

    public void setDebug(int debug)

  Set the debugging detail level for this component.

  Parameters:
    `debug` - The new debugging detail level

### getDelegate

    public boolean getDelegate()

  Return the "delegate first" flag for this class loader.

### setDelegate

    public void setDelegate(boolean delegate)

  Set the "delegate first" flag for this class loader.

  Parameters:
    `delegate` - The new "delegate first" flag

### setPermissions

    protected void setPermissions(java.lang.String path)

  If there is a Java SecurityManager create a read FilePermission or JndiPermission for the file directory path.

  Parameters:
    `path` - file directory path

### setPermissions

    protected void setPermissions(java.net.URL url)

  If there is a Java SecurityManager add a read FilePermission or JndiPermission for URL.

  Parameters:
    `url` - URL for a file or directory on local system

### addRepository

    public void addRepository(java.lang.String repository)

  Add a new repository to the set of places this ClassLoader can look for classes to be loaded.

  Specified by:
    `addRepository` in interface `Reloader`
  Parameters:
    `repository` - Name of a source of classes to be loaded, such as a directory pathname, a JAR file pathname, or a ZIP file pathname
  Throws:
    `java.lang.IllegalArgumentException` - if the specified repository is invalid or does not exist

### findRepositories

    public java.lang.String[] findRepositories()

  Return a String array of the current repositories for this class loader. If there are no repositories, a zero-length array is returned. For security reason, returns a clone of the Array (since String are immutable).

  Specified by:
    `findRepositories` in interface `Reloader`

### modified

    public boolean modified()

  This class loader doesn't check for reloading.

  Specified by:
    `modified` in interface `Reloader`

### toString

    public java.lang.String toString()

  Render a String representation of this object.

### findClass

    public java.lang.Class findClass(java.lang.String name)
                              throws java.lang.ClassNotFoundException

  Find the specified class in our local repositories, if possible. If not found, throw `ClassNotFoundException`.

  Parameters:
    `name` - Name of the class to be loaded
  Throws:
    `java.lang.ClassNotFoundException` - if the class was not found

### findResource

    public java.net.URL findResource(java.lang.String name)

  Find the specified resource in our local repository, and return a `URL` refering to it, or `null` if this resource cannot be found.

  Parameters:
    `name` - Name of the resource to be found

### findResources

    public java.util.Enumeration findResources(java.lang.String name)
                                        throws java.io.IOException

  Return an enumeration of `URLs` representing all of the resources with the given name. If no resources with this name are found, return an empty enumeration.

  Parameters:
    `name` - Name of the resources to be found
  Throws:
    `java.io.IOException` - if an input/output error occurs

### getResource

    public java.net.URL getResource(java.lang.String name)

  Find the resource with the given name. A resource is some data (images, audio, text, etc.) that can be accessed by class code in a way that is independent of the location of the code. The name of a resource is a "/"-separated path name that identifies the resource. If the resource cannot be found, return `null`.

  This method searches according to the following algorithm, returning as soon as it finds the appropriate URL. If the resource cannot be found, returns `null`.

  - If the `delegate` property is set to `true`, call the `getResource()` method of the parent class loader, if any.
  - Call `findResource()` to find this resource in our locally defined repositories.
  - Call the `getResource()` method of the parent class loader, if any.

  Parameters:
    `name` - Name of the resource to return a URL for

### getResourceAsStream

    public java.io.InputStream getResourceAsStream(java.lang.String name)

  Find the resource with the given name, and return an input stream that can be used for reading it. The search order is as described for `getResource()`, after checking to see if the resource data has been previously cached. If the resource cannot be found, return `null`.

  Parameters:
    `name` - Name of the resource to return an input stream for

### loadClass

    public java.lang.Class loadClass(java.lang.String name)
                              throws java.lang.ClassNotFoundException

  Load the class with the specified name. This method searches for classes in the same manner as `loadClass(String, boolean)` with `false` as the second argument.

  Parameters:
    `name` - Name of the class to be loaded
  Throws:
    `java.lang.ClassNotFoundException` - if the class was not found

### loadClass

    public java.lang.Class loadClass(java.lang.String name,
                                     boolean resolve)
                              throws java.lang.ClassNotFoundException

  Load the class with the specified name, searching using the following algorithm until it finds and returns the class. If the class cannot be found, returns `ClassNotFoundException`.
  - Call `findLoadedClass(String)` to check if the class has already been loaded. If it has, the same `Class` object is returned.
  - If the `delegate` property is set to `true`, call the `loadClass()` method of the parent class loader, if any.
  - Call `findClass()` to find this class in our locally defined repositories.
  - Call the `loadClass()` method of our parent class loader, if any.
  If the class was found using the above steps, and the `resolve` flag is `true`, this method will then call `resolveClass(Class)` on the resulting Class object.

  Parameters:
    `name` - Name of the class to be loaded
    `resolve` - If `true` then resolve the class
  Throws:
    `java.lang.ClassNotFoundException` - if the class was not found

### getPermissions

    protected final java.security.PermissionCollection getPermissions(java.security.CodeSource codeSource)

  Get the Permissions for a CodeSource. If this instance of StandardClassLoader is for a web application context, add read FilePermissions for the base directory (if unpacked), the context URL, and jar file resources.

  Returns:
    PermissionCollection for CodeSource

### parseProtocol

    protected static java.lang.String parseProtocol(java.lang.String spec)

  Parse URL protocol.

  Returns:
    String protocol

### addRepositoryInternal

    protected void addRepositoryInternal(java.lang.String repository)

  Add a repository to our internal array only.

  Parameters:
    `repository` - The new repository
  Throws:
    `java.lang.IllegalArgumentException` - if the manifest of a JAR file cannot be processed correctly

### convert

    protected static java.net.URL[] convert(java.lang.String[] input)

  Convert an array of String to an array of URL and return it.

  Parameters:
    `input` - The array of String to be converted

### convert

    protected static java.net.URL[] convert(java.lang.String[] input,
                                            java.net.URLStreamHandlerFactory factory)

  Convert an array of String to an array of URL and return it.

  Parameters:
    `input` - The array of String to be converted
    `factory` - Handler factory to use to generate the URLs

### findLoadedResource

    protected java.io.InputStream findLoadedResource(java.lang.String name)

  Finds the resource with the given name if it has previously been loaded and cached by this class loader, and return an input stream to the resource data. If this resource has not been cached, return `null`.

  Parameters:
    `name` - Name of the resource to return

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2003 Apache Software Foundation. All Rights Reserved.